/**
 * @author: Daniel Oltmanns <oltmanns@beuth-hochschule.de><br />
 * @since: 1 08/08/07<br />
 * @version: 1 08/08/07<br />
 * @license: <br />
 * @require: prototype<br />
 * <br />
 * This inserts a quiz into a webpage.
 */

if(typeof Class == 'undefined')
  throw("Quiz1OfN.js requires prototype.js");


var Quiz1OfN = Class.create();
Quiz1OfN.prototype =
{
	initialize: function(elementIdOfQuiz, quiz, options)
	{
		this.elementIdOfQuiz = elementIdOfQuiz;
		this.quiz = quiz;
		if(options == null)
		{
			options = [];
		}
		if(options.length != 10) // one option is missed
		{
			// set unset options
			if (options.htmlWrong == null)
				options.htmlWrong = "false";
			if (options.htmlRight == null)
				options.htmlRight = "true";
			if (options.classQuestion == null)
				options.classQuestion = "quizQuestion";
			if (options.classAnswer == null)
				options.classAnswer = "quizAnswer";
			if (options.classTable == null)
				options.classTable = "quizTable";
			if (options.classTdInput == null)
				options.classTdInput = "quizTdInput";
			if (options.classTdRightWrong == null)
				options.classTdRightWrong = "quizTdRightWrong";
			if (options.classTdAnswer == null)
				options.classTdAnswer = "quizTdAnswer";
			if (options.beforeQuizElement == null)
				options.beforeQuizElement = "";
			if (options.afterQuizElement == null)
				options.afterQuizElement = "";
		}
		this.htmlWrong = options.htmlWrong;
		this.htmlRight = options.htmlRight;
		this.classQuestion = options.classQuestion;
		this.classAnswer = options.classAnswer;
		this.classTable = options.classTable;
		this.classTdInput = options.classTdInput;
		this.classTdRightWrong = options.classTdRightWrong;
		this.classTdAnswer = options.classTdAnswer;
		this.beforeQuizElement = options.beforeQuizElement;
		this.afterQuizElement = options.afterQuizElement;
	},
	elementIdOfQuiz : null,
	quiz : null,
	htmlRight : null,
	htmlWrong : null,
	classQuestion : null,
	classAnswer : null,
	classTdInput : null,
	classTdRightWrong : null,
	classTdAnswer : null,
	classTable : null,
	beforeQuizElement : null,
	afterQuizElement : null,
	privateAllLines : '',
	privateInsertLine : function(line) {
		this.privateAllLines += line;
	},
	insert : function() {
		this.privateInsertLine(this.beforeQuizElement);
		for(var i=0; i<this.quiz.quizElements.length; i++) {
			this.privateInsertQuizElement(this.quiz.quizElements[i], i);
		};
		this.privateInsertLine(this.afterQuizElement);
		$(this.elementIdOfQuiz).innerHTML = this.privateAllLines;
		this.initBehaviour();
	},
	privateInsertQuizElement : function(quizElement, quizElementNo) {
		this.privateInsertLine('<table class="' + this.classTable + '">');
		this.privateInsertLine('<tr><th colspan="3" class="' + this.classQuestion + '">' + quizElement.question + '</th></tr>');
		for(var i=0; i<quizElement.answers.length; i++) {
			this.privateInsertQuizAnswer(quizElement, quizElementNo, quizElement.answers[i], i);
		};
		this.privateInsertLine('</table>');
	},
	privateInsertQuizAnswer : function(quizElement, quizElementNo, answer, answerNo) {
		this.privateInsertLine('<tr>');
		if(answerNo == quizElement.rightAnswer) {
			this.privateInsertQuizResultTd(this.htmlRight, quizElementNo, answerNo);
		}
		else {
			this.privateInsertQuizResultTd(this.htmlWrong, quizElementNo, answerNo);
		}
		this.privateInsertLine('<td class="' + this.classTdInput + '"><input type="radio" id="quizInput_' + quizElementNo + '_' + answerNo + '" name="quizInput_' + quizElementNo + '" /></td>');
		this.privateInsertLine('<td class="' + this.classTdAnswer + '"><div class="' + this.classAnswer + '">' + answer + '</div></td>');
		this.privateInsertLine('</tr>');
	},
	privateInsertQuizResultTd : function(content, quizElementNo, answerNo) {
			this.privateInsertLine('<td class="' + this.classTdRightWrong + '"><div style="visibility: hidden;" id="quizResult_' + quizElementNo + '_' + answerNo + '">' + content + '</div></td>');
	},
	initBehaviour : function() {
		for(var i=0; i<this.quiz.quizElements.length; i++) {
			this.privateInitBehaviourQuizElement(this.quiz.quizElements[i], i);
		};
	},
	privateInitBehaviourQuizElement : function(quizElement, quizElementNo) {
		for(var i=0; i<quizElement.answers.length; i++) {
			this.privateInitBehaviourQuizAnswer(quizElement, quizElementNo, quizElement.answers[i], i);
		};
	},
	privateInitBehaviourQuizAnswer : function(quizElement, quizElementNo, answer, answerNo) {
		$('quizInput_' + quizElementNo + '_' + answerNo).onclick = function() {
			var i=0;
			while($('quizResult_' + quizElementNo + '_' + i)) {
				$('quizResult_' + quizElementNo + '_' + i).style.visibility = 'hidden';
				i++;
			}
			$('quizResult_' + quizElementNo + '_' + answerNo).style.visibility = 'visible';
		}
	}
}