﻿//B.Stockhaus@Labor Online-Learning
//3.1.2006
// Geandert von Wiebke Buchhorn
// 08/2006
//
//klasse gehört zum symbol 'AudioPlayer' in der library
//-repräsentiert einen audioplayer zum laden eines files von extern
//-unterstützt id3-tags (titelanzeige) und ladefortschrittsanzeige
//-konvertierte attribute aus xml-file werden bei initialisierung übergeben 
//**************************************************************************************

class AudioPlayer extends MovieClip
{
	//vars
	private var audio_source:String;//aus AudioPlayer.xml
	private var audio_textLink:String;
	private var audio_javascriptFunction:Number;
	private var audio_textWinWidth:Number;
	private var audio_textWinHeight:Number;
	private var audio_title:String;
	private var audio_length:String;
	private var audio_loadAtStartup:Number;
	private var audio_enablePlayButtonAt:Number;
	private var audio_playAutomatic:Number;
	private var audio_displayTimeElapsed:Number;
	
	private var ID3Text:String;
	
	private var audioFile:Sound;
	private var position_buffer:Number;
	private var percentLoaded:Number;
	private var loaded:Boolean;
	private var started:Boolean;
	private var timer_ID1:Number;
	private var timer_ID2:Number;
	private var timer_ID3:Number;
	private var dragging:Boolean;
	
	//clips
	private var play_mc:MovieClip;
	private var pause_mc:MovieClip;
	private var rewind_mc:MovieClip;
	private var forward_mc:MovieClip;
	private var progressbar_mc:MovieClip;
	private var player_bg_mc:MovieClip;
	private var slider_mc:MovieClip;
	private var textmask_mc:MovieClip;
	private var infoClip_mc:MovieClip;
	private var info_mc:MovieClip;
	private var speaker_mc:MovieClip;
	
	//textfelder
	private var timer_txt:TextField;
	
	//**************************************************************************************
	public function AudioPlayer()
	{
		pause_mc.onRelease=function(){_parent.pause();};
		pause_mc.onRollOver=function(){this.gotoAndStop("over");};
		pause_mc.onRollOut=function(){this.gotoAndStop("out");};
		
		play_mc.onRelease=function(){_parent.play();};
		play_mc.onRollOver=function(){this.gotoAndStop("over");};
		play_mc.onRollOut=function(){this.gotoAndStop("out");};
		
		rewind_mc.onRelease=function(){_parent.rewind();};
		rewind_mc.onRollOver=function(){this.gotoAndStop("over");};
		rewind_mc.onRollOut=function(){this.gotoAndStop("out");};
		
		forward_mc.onRelease=function(){_parent.forward();};
		forward_mc.onRollOver=function(){this.gotoAndStop("over");};
		forward_mc.onRollOut=function(){this.gotoAndStop("out");};
		
		slider_mc.onPress=function(){_parent.startDragSlider();};
		slider_mc.onRelease=function(){_parent.stopDragSlider();};
		slider_mc.onReleaseOutside=function(){_parent.stopDragSlider(); this.gotoAndStop("out");};
		slider_mc.onRollOver=function(){this.gotoAndStop("over");};
		slider_mc.onRollOut=function(){this.gotoAndStop("out");};
		
		info_mc.onRollOver=function(){_parent.showInfoClip(); this.useHandCursor=false;};
		
		progressbar_mc.onRollOver=function(){this.useHandCursor=false;};
		progressbar_mc.onRelease=function(){_parent.jumpSlider()};
		
		progressbar_mc._visible=false;
		slider_mc._visible=false;
		textmask_mc._visible=false;
		speaker_mc._visible = true;
		
		// Verschiebung des Hintergrunds des Players
		player_bg_mc._y = 3;
	};
	
	public function init(audioInfo:Object):Boolean
	{
		//infos auslesen und speichern
		this.audio_source=audioInfo.source;
		this.audio_textLink=audioInfo.textLink;
		this.audio_javascriptFunction=audioInfo.javascriptFunction;
		this.audio_textWinWidth=audioInfo.textWinWidth;
		this.audio_textWinHeight=audioInfo.textWinHeight;
		this.audio_title=audioInfo.title;
		this.audio_length=audioInfo.length;
		this.audio_loadAtStartup=Number(audioInfo.loadAtStartup);
		this.audio_enablePlayButtonAt=Number(audioInfo.enablePlayButtonAt);
		this.audio_playAutomatic=Number(audioInfo.playAutomatic);
		this.audio_enablePlayButtonAt=Number(audioInfo.enablePlayButtonAt);
		this.audio_displayTimeElapsed=Number(audioInfo.displayTimeElapsed);
		
		this.loaded=false;
		this.position_buffer=0;
		this.started=false;
		
		//defaults setten
		setID3Text();
		showID3Time();

		if(!audio_enablePlayButtonAt || audio_enablePlayButtonAt=="")
			audio_enablePlayButtonAt=0;
			
		//falls gefordert, ladevorgang starten
		if(audio_loadAtStartup)//wenn definiert (bzw. > 0)
			play();
		
		return true;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//clip mit link zum download, evtl. link auf externe datei und titel einblenden
	public function showInfoClip():Void
	{
		if(this.getInstanceAtDepth(1)==undefined){
			infoClip_mc = this.attachMovie("InfoClip", "infoClip_mc", 1);
			infoClip_mc.init( audio_source, getID3Text(), audio_textLink, audio_javascriptFunction, audio_textWinWidth, audio_textWinHeight );
		}
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//sound von extern in objekt laden; kontrolle nach erfolgreichem vorgang weitergeben
	public function loadFile():Void
	{
		audioFile=new Sound(this);
		
		audioFile.onLoad=function(success:Boolean)
		{
			_root.ap_obj.loadComplete();
		};
	
		//update-aufruf, wenn id3-daten vorhanden. evtl. werden diese dann angezeigt
		audioFile.onID3=function(success:Boolean)
		{
			_root.ap_obj.setID3Text();
			_root.ap_obj.showID3Time();
		};
		
		//started normalerweise per default ab ca. 4% (durch flag "streaming=true")
		audioFile.loadSound(audio_source, true);
		showProgress();
		//hier erst starten, wenn erwünscht (siehe showProgress->onEnterFrame)
		audioFile.stop();
	};

	///////////////////////////////////////////////////////////////////////////////////////
	//lade-fortschritt anzeigen; erst ab definiertem prozentsatz anzeigen
	public function showProgress()
	{
		this.onEnterFrame=function(){
			if(audioFile){
				percentLoaded = audioFile.getBytesLoaded()/audioFile.getBytesTotal()*100;
				
				//unbedingt abfangen!!!
				if(!isNaN(percentLoaded)){
					
					if(percentLoaded>0){
						//progress_txt.text=Math.round(percentLoaded)+"%";
						progressbar_mc._visible=true;
						progressbar_mc.gotoAndStop(Math.round(percentLoaded));
					}
					
					if( !isNaN(audio_playAutomatic) && Math.round(percentLoaded)>=audio_playAutomatic && !started){
						audioFile.start();
						started=true;
						startTimer();
					}
					
					if(percentLoaded>=100){
						delete onEnterFrame;
						//startTimer();
						slider_mc._visible=true;
					}
				}
			}
		};
		
	};
	///////////////////////////////////////////////////////////////////////////////////////
	//audiofile abspielen - laden oder ab position fortsetzen
	public function play():Void
	{
		speaker_mc.gotoAndPlay("start");
		//erster aufruf; file laden
		//default-infos setzen (bei starten des ladevorgangs)
		if(!percentLoaded){
			showID3Time();	
			loadFile();
		}
		//sind mindestens 'audio_enablePlayButtonAt' % geladen, von anfang abspielen
		else if(percentLoaded>audio_enablePlayButtonAt && position_buffer==0){
			audioFile.start();
			started=true;
			//timer erst starten, wenn alles geladen ist. sonst wird mumpitz brechnet.
			if(percentLoaded>=100)
				startTimer();
		}
		//apspielen wurde zuvor per pause-taste angehalten - weiter
		else if(position_buffer>0){
			audioFile.start(position_buffer/1000);
			if(percentLoaded>=100){
				//unbedingt intervalle löschen
				clearIntervals();
				startTimer();
			}
			//flag setten (wichtig für onEnterFrame)
			position_buffer=0;
		}
		//rumdrücken unterbinden
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//stoppt wiedergabe, buffered gespielte zeit für's fortsetzen
	public function pause():Void
	{
		if(audioFile)
		{
			position_buffer = audioFile.position;
			audioFile.stop();
			clearIntervals();
			speaker_mc.gotoAndStop("stopp");
		}
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//ans ende springen
	public function forward():Void
	{
		if(loaded){
			slider_mc._x = progressbar_mc._x + progressbar_mc._width - slider_mc._width/2;
			audioFile.stop();
			clearIntervals();
			timer_txt.text=formatTime(0);
			speaker_mc.gotoAndStop("stopp");
		}
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//an den anfang springen
	public function rewind():Void
	{
		if(audioFile)
		{
			audioFile.start();
			speaker_mc.gotoAndPlay("start");
			if(percentLoaded>=100){
				slider_mc._x= progressbar_mc._x + slider_mc._width/2;
				showID3Time();
				startTimer();
			}
		}
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//aufruf vom handler onID3 des Sound-Objekts:
	//gewünschte ID3-info anzeigen; falls nicht vorhanden XML-infos (AudioPlayer.xml) anzeigen
	public function showID3Time():Void
	{	
		//gesamtlänge anzeigen
		if(audio_length!=undefined && audio_length!=""){//angabe aus xml wird bevorzugt
			timer_txt.text=audio_length;
		}
		else if(audioFile.id3.TLEN!=undefined){//ansonsten id3-tag auswerten
			timer_txt.text=formatTime(audioFile.id3.TLEN);
		}
		else{
			timer_txt.text="--:--";//nichts anzeigen
		}
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//aufruf vom handler onID3 des Sound-Objekts:
	//ID3-text setten; falls nicht vorhanden XML-infos (AudioPlayer.xml) setten
	public function setID3Text():Void
	{	
		//titel anzeigen
		if(audio_title!=undefined && audio_title!=""){//angabe aus xml wird bevorzugt
			ID3Text=audio_title;
		}
		else if(audioFile.id3.TIT2!=undefined){
			ID3Text=audioFile.id3.TIT2;
		}
		else{
			ID3Text="";
		}
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//gesetzten titel returnen. entweder ID3.TIT2 oder title aus XML (bevorzugt, falls definiert)
	public function getID3Text():String
	{	
		return ID3Text;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//restzeit in korrektes format wandeln und returnen
	private function formatTime(ms_remaining:Number):String{
		
		var min:Number=Math.floor(ms_remaining/1000/60);
		var sec:Number=Math.round( ((ms_remaining/1000/60)-min)*60 );
		
		//trace(((ms_remaining/1000/60)-min)*60)
		
		//60 abfangen
		if(sec==60)
			sec=0;
		
		//minuten formatieren
		if(min<10)
			var min_str:String="0"+min;
		else
			var min_str:String=min.toString();
		
		//sekunden formatieren
		if(sec<10)
			var sec_str:String="0"+sec;
		else
			var sec_str:String=sec.toString();
		
		//fehler bei der berechnung abfangen
		if(min<0 || sec<0)
			return ("");//00:00
		else
			return (min_str+":"+sec_str);
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//slider an position draggen lassen
	public function startDragSlider():Void
	{
		slider_mc.startDrag(false, 
							progressbar_mc._x + Math.floor(slider_mc._width/2), 
							progressbar_mc._y + 0.2, 
							progressbar_mc._x + progressbar_mc._width - Math.ceil(slider_mc._width/2) + 1, 
							progressbar_mc._y + 0.2
							);
		dragging=true;
		clearIntervals();
		textmask_mc._visible=true;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//zeitanzeige updaten; voraussichtliche abspielzeit bei loslassen des sliders
	public function onMouseMove():Void
	{
		//var x = progressbar_mc._x + slider_mc._width/2 + Math.round((progressbar_mc._width - slider_mc._width) * audioFile.position / audioFile.duration);//
		if(dragging){
			//position ins verhältnis zu breite der bar und länge des audiofiles setzen
			var dist:Number=slider_mc._x - (progressbar_mc._x + slider_mc._width/2);
			if (dist < 0)
				dist = 0;
			if (dist > progressbar_mc._width - slider_mc._width)
				dist = progressbar_mc._width - slider_mc._width;
			//buffer setten
			var time_expected = dist * audioFile.duration / (progressbar_mc._width - slider_mc._width);
			timer_txt.htmlText=formatTime(audioFile.duration - time_expected);
		}
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//draggen vom slider stoppen, entsprechende position abspielen
	private function stopDragSlider():Void
	{
		slider_mc.stopDrag();
		dragging=false;
		//timer_txt.text="";
		//position ins verhältnis zu breite der bar und länge des audiofiles setzen
		var dist:Number=slider_mc._x - (progressbar_mc._x + slider_mc._width/2);
			if (dist < 0)
				dist = 0;
			if (dist > progressbar_mc._width - slider_mc._width)
				dist = progressbar_mc._width - slider_mc._width;
		//buffer setten
		position_buffer = dist * audioFile.duration / (progressbar_mc._width - slider_mc._width);
		//an position abspielen lassen
		play();
		textmask_mc._visible=false;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//slider bei click auf bar an position versetzen und audio ab position abspielen
	private function jumpSlider():Void
	{
		if(percentLoaded>=100){
			//timer_txt.text="";//00:00
			slider_mc._x=progressbar_mc._xmouse + progressbar_mc._x;
			stopDragSlider();
		}
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//slider positionieren; aufruf alle 500 ms
	private function updateSliderPosition():Void
	{
		if(!dragging){
			 var x = progressbar_mc._x + slider_mc._width/2 + Math.round((progressbar_mc._width - slider_mc._width) * audioFile.position / audioFile.duration);//
			 slider_mc._x = x;
		}
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//aufruf vom handler onLoad des Sound-Objekts:
	//flag setten
	public function loadComplete():Void
	{
		loaded=true;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//timer erst starten, wenn der erste bruchteil einer sekunde des audiofiles abgelaufen ist 
	//check per 'function checkCorrectStart'
	private function startTimer():Void
	{	
		//intervalle löschen falls vorhanden
		clearIntervals();
		timer_ID1 = setInterval( this, "checkCorrectStart", 1);
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//timer-refresh alle sekunde ausführen - erst starten, wenn der erste bruchteil einer sekunde 
	//des audiofiles abgelaufen ist  
	private function checkCorrectStart():Void
	{
		if( ((audioFile.duration-audioFile.position)%1000)<=100 ){//toleranz 100 ms
			clearInterval(timer_ID1);
			timer_ID2 = setInterval(this, "refreshTimer", 1000);
			timer_ID3 = setInterval(this, "updateSliderPosition", 100);
		}
		else
			return;
	};
	
	///////////////////////////////////////////////////////////////////////////////////////
	//timer aktualisieren; aufruf 1/sek
	private function refreshTimer():Void
	{
		if(!audio_displayTimeElapsed)//restzeit anzeigen
			timer_txt.text=formatTime(audioFile.duration - audioFile.position);
		else
			timer_txt.text=formatTime(audioFile.position);//abgelaufene zeit anzeigen
		
		//abspielen beendet, aufräumen
		if(audioFile.duration - audioFile.position<=0){
			clearIntervals();
			slider_mc._x=progressbar_mc._x + slider_mc._width/2;
			showID3Time();
		}
	};

	///////////////////////////////////////////////////////////////////////////////////////
	//alle 3 intervalle löschen
	private function clearIntervals():Void
	{
		clearInterval(timer_ID1);
		clearInterval(timer_ID2);
		clearInterval(timer_ID3);
	};
};//class